/**
 * generated by Xtext 2.16.0
 */
package org.xtext.ungs.drake.drake;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Formulation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.ungs.drake.drake.Formulation#getDefinitions <em>Definitions</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.Formulation#getFunction <em>Function</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.Formulation#getExpression <em>Expression</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.Formulation#getInequation <em>Inequation</em>}</li>
 * </ul>
 *
 * @see org.xtext.ungs.drake.drake.DrakePackage#getFormulation()
 * @model
 * @generated
 */
public interface Formulation extends EObject
{
  /**
   * Returns the value of the '<em><b>Definitions</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.ungs.drake.drake.Set}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Definitions</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Definitions</em>' containment reference list.
   * @see org.xtext.ungs.drake.drake.DrakePackage#getFormulation_Definitions()
   * @model containment="true"
   * @generated
   */
  EList<Set> getDefinitions();

  /**
   * Returns the value of the '<em><b>Function</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Function</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Function</em>' attribute.
   * @see #setFunction(String)
   * @see org.xtext.ungs.drake.drake.DrakePackage#getFormulation_Function()
   * @model
   * @generated
   */
  String getFunction();

  /**
   * Sets the value of the '{@link org.xtext.ungs.drake.drake.Formulation#getFunction <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Function</em>' attribute.
   * @see #getFunction()
   * @generated
   */
  void setFunction(String value);

  /**
   * Returns the value of the '<em><b>Expression</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Expression</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Expression</em>' containment reference.
   * @see #setExpression(LinearExpression)
   * @see org.xtext.ungs.drake.drake.DrakePackage#getFormulation_Expression()
   * @model containment="true"
   * @generated
   */
  LinearExpression getExpression();

  /**
   * Sets the value of the '{@link org.xtext.ungs.drake.drake.Formulation#getExpression <em>Expression</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Expression</em>' containment reference.
   * @see #getExpression()
   * @generated
   */
  void setExpression(LinearExpression value);

  /**
   * Returns the value of the '<em><b>Inequation</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.ungs.drake.drake.LinearInequation}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Inequation</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Inequation</em>' containment reference list.
   * @see org.xtext.ungs.drake.drake.DrakePackage#getFormulation_Inequation()
   * @model containment="true"
   * @generated
   */
  EList<LinearInequation> getInequation();

} // Formulation
